﻿/*
 * Created by SharpDevelop.
 * User: Administrator
 * Date: 6/16/2009
 * Time: 4:09 PM
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;
using MapSharpLib;


namespace NodeApp
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public partial class MainForm : Form
	{
		Dictionary<int, MRNetworkNode> Nodes;
		
		public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			Nodes = new Dictionary<int, MRNetworkNode>();
			
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			//
		}
		
		void Button1Click(object sender, EventArgs e)
		{
			int port = (int)numericUpDown1.Value++;
			if(Nodes.ContainsKey(port))
			{
				textBox1.AppendText("Node Already Exists at port " + port.ToString() + "\n");
				return;
			}
			
			string[] nodelines = textBox2.Lines;
			string[] newNodeLines = new string[nodelines.Length+1];
			Array.Copy(nodelines,newNodeLines,nodelines.Length);
			newNodeLines[nodelines.Length] = port.ToString();
			textBox2.Lines = newNodeLines;
			
			Nodes.Add(port, new MRNetworkNode(port));
			
			
			textBox1.AppendText("Node Started at port " + port.ToString() + "\n");
		}
		
		void Button2Click(object sender, EventArgs e)
		{
			int port = (int)numericUpDown1.Value--;
			if(!Nodes.ContainsKey(port))
			{
				textBox1.AppendText("Node Doesn't Exist at port " + port.ToString() + "\n");
				return;
			}
			
			string[] nodelines = textBox2.Lines;
			string[] newNodeLines = new string[nodelines.Length-1];
			string portS = port.ToString();
			int index = 0;
			for(int i=0; i<nodelines.Length; i++)
			{
				if(!nodelines[i].Equals(portS))
					newNodeLines[index++] = nodelines[i];
			}
			textBox2.Lines = newNodeLines;
			
			
			Nodes[port].Stop();
			Nodes.Remove(port);
			
			textBox1.AppendText("Node Stopped at port " + port.ToString() + "\n");
		}
		
		void MainFormFormClosing(object sender, FormClosingEventArgs e)
		{
			foreach(KeyValuePair<int, MRNetworkNode> kvp in Nodes)
				kvp.Value.Stop();
		}
	}
}
